//===============================================================================
// Microsoft patterns & practices
// Web Client Software Factory
//-------------------------------------------------------------------------------
// Copyright (C) Microsoft Corporation.  All rights reserved.
// THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY
// OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT
// LIMITED TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
// FITNESS FOR A PARTICULAR PURPOSE.
//-------------------------------------------------------------------------------
// The example companies, organizations, products, domain names,
// e-mail addresses, logos, people, places, and events depicted
// herein are fictitious.  No association with any real company,
// organization, product, domain name, email address, logo, person,
// places, or events is intended or should be inferred.
//===============================================================================

using System.ComponentModel;
using System.Web.UI;

namespace DreamDriven.Components.DataSource.EventsArgs
{
	/// <summary>
	/// Provides data for the <see cref="DomainObjectDataSource.Selecting"/> event.
	/// </summary>
    public class DomainObjectDataSourceSelectingEventArgs : CancelEventArgs
    {
	    /// <summary>
		/// Initializes a new instance of <see cref="DomainObjectDataSourceSelectingEventArgs"/>.
		/// </summary>
		/// <param name="arguments">The <see cref="DataSourceSelectArguments"/> with the select arguments.</param>
        public DomainObjectDataSourceSelectingEventArgs(DataSourceSelectArguments arguments)
        {
            Arguments = arguments;
        }

	    /// <summary>
	    /// Gets the <see cref="DataSourceSelectArguments"/> with the select arguments.
	    /// </summary>
	    public DataSourceSelectArguments Arguments { get; set; }
    }
}
