﻿using System.Web.UI;
using DreamDriven.ObjectModel.Mvp;

namespace DreamDriven.Web
{
    public class BaseControl : Control, IView, IViewStateControl
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="BaseUserControl"/> class.
        /// </summary>
        protected BaseControl()
        {
            PresenterBinder.Bind(this);
        }

        /// <summary>
        /// Gets a dictionary of state information that allows you to save and 
        /// restore the view state of a server control across multiple requests for the same page.
        /// </summary>
        /// <value></value>
        /// <returns>An instance of the <see cref="T:System.Web.UI.StateBag"/> class that contains the server control's view-state information.</returns>
        public new StateBag ViewState
        {
            get { return base.ViewState; }
        }
    }
}
