using System;
using System.Web;
using DreamDriven.ObjectModel.Mvp;
using DreamDriven.Web.Mvp;

namespace DreamDriven.Web
{
    [PresenterBinding(typeof(ApplicationPresenter))]
    public class BaseHttpApplication : HttpApplication, IApplicationView
    {
        public event EventHandler ApplicationDisposing;

        public BaseHttpApplication()
        {
            PresenterBinder.Bind(this);
        }

        public void Application_End()
        {
            ApplicationDisposing(this, EventArgs.Empty);
        }
    }
}